﻿using System;
using System.Collections.Generic;
using System.Text;
using mxdev_csif;

namespace LED
{
    class Program
    {
        const int maxLedCount = 8;

        static void Main(string[] args)
        {
            int i = 0;
            int port = 0, value = 0;
            string sled = "";

            System.Console.WriteLine("LED Test Program");
            System.Console.WriteLine("\t (0) Exit Program");
            System.Console.WriteLine("\t (1) Display LED");
            System.Console.WriteLine("\t (2) Set LED value");


            // read a char.
            string sin = System.Console.ReadLine();
            int n = int.Parse(sin);
            IntPtr fd = mxdev.mxgpio_open();
            if (IntPtr.Zero==fd)
            {
                System.Console.WriteLine("Unable to open device.\n");
                return;
            }

            do
            {
                switch (n)
                {
                    // if char == '1', display the LED0 ~ LED7
                    case 1:
                        for (i = 0; i < maxLedCount; i++)
                        {
                            value = mxdev.mxgpio_get_data(fd, (uint)i);
                            System.Console.WriteLine("Din{0}={1}", i, value);
                        }
                        break;
                    // if char == '2', Set teh LED value
                    case 2:
                        // read port Nnmber from console
                        System.Console.Write(string.Format("Input the LED Port Number (0 ~ {0}) = ", maxLedCount-1));
                        sled = System.Console.ReadLine();
                        port = int.Parse(sled);

                        // read port value from console
                        System.Console.Write("Input the LED value (0 or 1) = ");
                        sled = System.Console.ReadLine();
                        value = int.Parse(sled);

                        System.Console.WriteLine("Set LED{0}={1}", port, value);

                        if (0 != mxdev.mxgpio_set_data(fd, (uint)port, value))
                        {
                            System.Console.WriteLine("mxgpio_set_data fail!");
                            break;
                        }
                        break;

                    default:
                        break;
                }
                sin = System.Console.ReadLine();
                n = int.Parse(sin);
            } while (n != 0);

            mxdev.mxgpio_close(fd);
        }
    }
}
