/*  Copyright (C) MOXA Inc. All rights reserved.
    This software is distributed under the terms of the
    MOXA License.  See the file COPYING-MOXA for details.
*/

#include "stdafx.h"
#include <windows.h>
#include "..\\Include\\mxdev.h"

#define LED_PORT_NUMBER 8 

int _tmain(int argc, _TCHAR* argv[])
{
    HANDLE hLedDev;
    int port_no;
    int data;
    int nLED = 0;
    int nRet = 0;
    int port = 0;
    int mode = 0;
    int n = 0;

    TCHAR sin;
    TCHAR smode;

    _tprintf(_T("LED Test Program\r\n"));
    _tprintf(_T("\t (0) Exit Program\r\n"));
    _tprintf(_T("\t (1) Display LED\r\n"));
    _tprintf(_T("\t (2) Set LED value\r\n"));
	
    sin = _gettchar();
    n = _tstoi(&sin);

    do
    {
        switch (n)
        {
            // if char == '1', display the LED output status
            case 1:
                // Open device
                hLedDev = mxgpio_open();

                for (int i = 0; i < LED_PORT_NUMBER; i++)
                {
                    // Get digital input
                    port_no = i;
                    nLED = mxgpio_get_data( hLedDev, port_no);
                    _tprintf(_T("LED[%d] = %d\r\n"), port_no, nLED);
                }

                // Close device
                mxgpio_close(hLedDev);
                break;
		
            // if char == '2', Set the LED output
            case 2:
                // Get Port Number
                _gettchar();
                _tprintf(_T("Input the Port Number (0 ~ %d) = \r\n"), LED_PORT_NUMBER-1);
                smode = _gettchar();
                port_no = _tstoi(&smode);

                // Get Value
                _gettchar();
                _tprintf(_T("Input the value (0 or 1) = "));
                smode = _gettchar();
                data = _tstoi(&smode);

                // Open device
                hLedDev = mxgpio_open();
				
				// Set LED
                nRet = mxgpio_set_data( hLedDev, port_no, data);

                if ( nRet == -1 )
                {
                    _tprintf(_T("Set led signal fail!\r\n"));
                }
                else
                {
                    _tprintf(_T("Set led signal success!\r\n"));
                }

                // Close device
                mxgpio_close(hLedDev);
                break;
        }
		_gettchar();
        sin = _gettchar();
        n = _tstoi(&sin);
    } while (n != 0);

    return 0;
}
